require 'active_support/core_ext/module/delegation'

module Retag
  class Service

    include Retag::Utils

    attr_reader :name, :config, :repo, :release, :suffix

    delegate :revision, :branch, to: :repo

    def initialize(name, config, release, branch:, suffix:)
      @name = name
      @config = config
      @repo = Retag::Repo.new(config['repo'], branch)
      @release = release
      @suffix = suffix
    end

    def images
      @images ||= config['images'].map{|img| Retag::Image.new(img, revision, suffix: @suffix) }
    end
  end
end

